// RecsView.cpp : implementation of the CRecsView class
//

#include "stdafx.h"
#include "Recs.h"

#include "RecsDoc.h"
#include "RecsView.h"
#include ".\recsview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CRecsView

IMPLEMENT_DYNCREATE(CRecsView, CView)

BEGIN_MESSAGE_MAP(CRecsView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CRecsView construction/destruction

CRecsView::CRecsView()
: m_bCaptured(false)
, m_pntStart(0)
{
	// TODO: add construction code here

}

CRecsView::~CRecsView()
{
}

BOOL CRecsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CRecsView drawing

void CRecsView::OnDraw(CDC* pDC)
{
	CRecsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);


    int pointIndex = pDoc->m_pointIndex;

    for (int i=0; i<pointIndex; ++i)
    {
        pDC->Rectangle(CRect(pDoc->m_points[i], pDoc->m_szRect));
    }
}


// CRecsView printing

BOOL CRecsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CRecsView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CRecsView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CRecsView diagnostics

#ifdef _DEBUG
void CRecsView::AssertValid() const
{
	CView::AssertValid();
}

void CRecsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CRecsDoc* CRecsView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRecsDoc)));
	return (CRecsDoc*)m_pDocument;
}
#endif //_DEBUG


// CRecsView message handlers

void CRecsView::OnLButtonDown(UINT nFlags, CPoint point)
{
    CRecsDoc *pDoc = GetDocument();

    // don't go past the end of the 100 points allocated
    if (pDoc->m_pointIndex == 100)
       return;

	CClientDC dc(this);
	OnPrepareDC(&dc);

	CPoint pointLP(point);
	dc.DPtoLP(&pointLP);

    //store the click location
    pDoc->m_points[pDoc->m_pointIndex] = pointLP;
    pDoc->m_pointIndex++;

    Invalidate();
}

void CRecsView::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

    if (GetDocument()->m_pointIndex == 0)
       return;

	CRect rect(GetDocument()->m_points[0], GetDocument()->m_szRect);
	
	CClientDC dc(this);
	OnPrepareDC(&dc);

	dc.LPtoDP(&rect);
	//rect.NormalizeRect();
	CPoint pointLP(point);
	dc.DPtoLP(&pointLP);

	if (rect.PtInRect(point)) {
		m_bCaptured = true;
		m_pntStart = pointLP;
		this->SetCapture();
	}
}

void CRecsView::OnRButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	if (m_bCaptured) {
		InvalidateOldAndNew(point);

		m_bCaptured = false;
		::ReleaseCapture();
	}
	CView::OnRButtonUp(nFlags, point);
}

void CRecsView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	if (m_bCaptured) {
		InvalidateOldAndNew(point);
	}

	CView::OnMouseMove(nFlags, point);
}

void CRecsView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
}

void CRecsView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: Add your specialized code here and/or call the base class
	pDC->SetMapMode(MM_HIENGLISH);
}

void CRecsView::InvalidateOldAndNew(CPoint point)
{
	CClientDC dc(this);
	OnPrepareDC(&dc);
	
	CRect rect(GetDocument()->m_points[0], GetDocument()->m_szRect);
	dc.LPtoDP(&rect);
	InvalidateRect(&rect);

	CPoint pointLP(point);
	dc.DPtoLP(&pointLP);
	GetDocument()->m_points[0] += pointLP - m_pntStart;

	rect = CRect(GetDocument()->m_points[0], GetDocument()->m_szRect);
	dc.LPtoDP(&rect);
	InvalidateRect(&rect);
	
	m_pntStart = pointLP;
}
